/* ***********************************************************
 * This file was automatically generated on 2012-08-01.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for sensing current of up to 25A
	/// </summary>
	public class BrickletCurrent25 : Device 
	{
		private static byte FUNCTION_GET_CURRENT = 1;
		private static byte FUNCTION_CALIBRATE = 2;
		private static byte FUNCTION_IS_OVER_CURRENT = 3;
		private static byte FUNCTION_GET_ANALOG_VALUE = 4;
		private static byte FUNCTION_SET_CURRENT_CALLBACK_PERIOD = 5;
		private static byte FUNCTION_GET_CURRENT_CALLBACK_PERIOD = 6;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
		private static byte FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = 9;
		private static byte FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = 10;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 13;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 14;
		private static byte CALLBACK_CURRENT = 15;
		private static byte CALLBACK_ANALOG_VALUE = 16;
		private static byte CALLBACK_CURRENT_REACHED = 17;
		private static byte CALLBACK_ANALOG_VALUE_REACHED = 18;
		private static byte CALLBACK_OVER_CURRENT = 19;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletCurrent25.SetCurrentCallbackPeriod"/>. The parameter is the current of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletCurrent25.Current"/> is only triggered if the current has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Current(short current);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletCurrent25.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletCurrent25.AnalogValue"/> is only triggered if the current has changed since the
		///  last triggering.
		/// </summary>
		public delegate void AnalogValue(ushort value);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletCurrent25.SetCurrentCallbackThreshold"/> is reached.
		///  The parameter is the current of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletCurrent25.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void CurrentReached(short current);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletCurrent25.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletCurrent25.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void AnalogValueReached(ushort value);

		/// <summary>
		///  This callback is triggered when an over current is measured
		///  (see <see cref="Tinkerforge.BrickletCurrent25.IsOverCurrent"/>).
		/// </summary>
		public delegate void OverCurrent();

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletCurrent25(string uid) : base(uid) 
		{
			this.expectedName = "Current25 Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_CURRENT] = new MessageCallback(CallbackCurrent);
			messageCallbacks[CALLBACK_ANALOG_VALUE] = new MessageCallback(CallbackAnalogValue);
			messageCallbacks[CALLBACK_CURRENT_REACHED] = new MessageCallback(CallbackCurrentReached);
			messageCallbacks[CALLBACK_ANALOG_VALUE_REACHED] = new MessageCallback(CallbackAnalogValueReached);
			messageCallbacks[CALLBACK_OVER_CURRENT] = new MessageCallback(CallbackOverCurrent);
		}

		/// <summary>
		///  Returns the current of the sensor. The value is in mA
		///  and between -25000mA and 25000mA.
		///  
		///  If you want to get the current periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletCurrent25.Current"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletCurrent25.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public short GetCurrent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CURRENT, out response);

			return LEConverter.ShortFrom(4, response);
		}

		/// <summary>
		///  Calibrates the 0 value of the sensor. You have to call this function
		///  when there is no current present. 
		///  
		///  The zero point of the current sensor
		///  is depending on the exact properties of the analog to digital converter,
		///  the length of the Bricklet cable and the temperature. Thus, if you change
		///  the Brick or the environment in which the Bricklet is used, you might
		///  have to recalibrate.
		///  
		///  The resulting calibration will be saved on the EEPROM of the Current
		///  Bricklet.
		/// </summary>
		public void Calibrate()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_CALIBRATE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns true if more than 25A were measured.
		///  
		///  <note>
		///   To reset this value you have to power cycle the Bricklet.
		///  </note>
		/// </summary>
		public bool IsOverCurrent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_IS_OVER_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_IS_OVER_CURRENT, out response);

			return LEConverter.BoolFrom(4, response);
		}

		/// <summary>
		///  Returns the value as read by a 12 bit analog to digital converter.
		///  The value is between 0 and 4095.
		///  
		///  <note>
		///   The value returned by <see cref="Tinkerforge.BrickletCurrent25.GetCurrent"/> is averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletCurrent25.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletCurrent25.GetAnalogValue"/> is,
		///   if you need the full resolution of the analog to digital converter.
		///  </note>
		///  
		///  If you want the analog value periodically, it is recommended to use the 
		///  callback <see cref="Tinkerforge.BrickletCurrent25.AnalogValue"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletCurrent25.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public ushort GetAnalogValue()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletCurrent25.Current"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletCurrent25.Current"/> is only triggered if the current has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetCurrentCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CURRENT_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletCurrent25.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public uint GetCurrentCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CURRENT_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CURRENT_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletCurrent25.AnalogValue"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletCurrent25.AnalogValue"/> is only triggered if the analog value has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletCurrent25.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public uint GetAnalogValueCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletCurrent25.CurrentReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off."
		///   "'o'",    "Callback is triggered when the current is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the current is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetCurrentCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletCurrent25.SetCurrentCallbackThreshold"/>.
		/// </summary>
		public void GetCurrentCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.ShortFrom(5, response);
			max = LEConverter.ShortFrom(7, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletCurrent25.AnalogValueReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off."
		///   "'o'",    "Callback is triggered when the current is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the current is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, ushort min, ushort max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletCurrent25.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out ushort min, out ushort max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.UShortFrom(5, response);
			max = LEConverter.UShortFrom(7, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///   <see cref="Tinkerforge.BrickletCurrent25.CurrentReached"/>, <see cref="Tinkerforge.BrickletCurrent25.AnalogValueReached"/>
		///  
		///  are triggered, if the thresholds
		///  
		///   <see cref="Tinkerforge.BrickletCurrent25.SetCurrentCallbackThreshold"/>, <see cref="Tinkerforge.BrickletCurrent25.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletCurrent25.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetCurrent(out short current)
		{
			current = GetCurrent();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void IsOverCurrent(out bool over)
		{
			over = IsOverCurrent();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValue(out ushort value)
		{
			value = GetAnalogValue();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetCurrentCallbackPeriod(out uint period)
		{
			period = GetCurrentCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValueCallbackPeriod(out uint period)
		{
			period = GetAnalogValueCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		internal int CallbackCurrent(byte[] data_)
		{
			short current = LEConverter.ShortFrom(4, data_);

			((Current)callbacks[CALLBACK_CURRENT])(current);
			return 6;
		}

		internal int CallbackAnalogValue(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValue)callbacks[CALLBACK_ANALOG_VALUE])(value);
			return 6;
		}

		internal int CallbackCurrentReached(byte[] data_)
		{
			short current = LEConverter.ShortFrom(4, data_);

			((CurrentReached)callbacks[CALLBACK_CURRENT_REACHED])(current);
			return 6;
		}

		internal int CallbackAnalogValueReached(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValueReached)callbacks[CALLBACK_ANALOG_VALUE_REACHED])(value);
			return 6;
		}

		internal int CallbackOverCurrent(byte[] data_)
		{
			((OverCurrent)callbacks[CALLBACK_OVER_CURRENT])();
			return 4;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Current))
			{
				callbacks[CALLBACK_CURRENT] = d;
			}
			else if(d.GetType() == typeof(AnalogValue))
			{
				callbacks[CALLBACK_ANALOG_VALUE] = d;
			}
			else if(d.GetType() == typeof(CurrentReached))
			{
				callbacks[CALLBACK_CURRENT_REACHED] = d;
			}
			else if(d.GetType() == typeof(AnalogValueReached))
			{
				callbacks[CALLBACK_ANALOG_VALUE_REACHED] = d;
			}
			else if(d.GetType() == typeof(OverCurrent))
			{
				callbacks[CALLBACK_OVER_CURRENT] = d;
			}
		}
	}
}
