/* ***********************************************************
 * This file was automatically generated on 2012-08-01.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for sensing distance via infrared
	/// </summary>
	public class BrickletDistanceIR : Device 
	{
		private static byte FUNCTION_GET_DISTANCE = 1;
		private static byte FUNCTION_GET_ANALOG_VALUE = 2;
		private static byte FUNCTION_SET_SAMPLING_POINT = 3;
		private static byte FUNCTION_GET_SAMPLING_POINT = 4;
		private static byte FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = 5;
		private static byte FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = 6;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
		private static byte FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = 9;
		private static byte FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = 10;
		private static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
		private static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 13;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 14;
		private static byte CALLBACK_DISTANCE = 15;
		private static byte CALLBACK_ANALOG_VALUE = 16;
		private static byte CALLBACK_DISTANCE_REACHED = 17;
		private static byte CALLBACK_ANALOG_VALUE_REACHED = 18;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackPeriod"/>. The parameter is the distance of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletDistanceIR.Distance"/> is only triggered if the distance has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Distance(ushort distance);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletDistanceIR.AnalogValue"/> is only triggered if the distance has changed since the
		///  last triggering.
		/// </summary>
		public delegate void AnalogValue(ushort value);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackThreshold"/> is reached.
		///  The parameter is the distance of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void DistanceReached(ushort distance);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void AnalogValueReached(ushort value);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletDistanceIR(string uid) : base(uid) 
		{
			this.expectedName = "Distance IR Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_DISTANCE] = new MessageCallback(CallbackDistance);
			messageCallbacks[CALLBACK_ANALOG_VALUE] = new MessageCallback(CallbackAnalogValue);
			messageCallbacks[CALLBACK_DISTANCE_REACHED] = new MessageCallback(CallbackDistanceReached);
			messageCallbacks[CALLBACK_ANALOG_VALUE_REACHED] = new MessageCallback(CallbackAnalogValueReached);
		}

		/// <summary>
		///  Returns the distance measured by the sensor. The value is in mm and possible
		///  distance ranges are 40 to 300, 100 to 800 and 200 to 1500, depending on the
		///  selected IR sensor.
		///  
		///  If you want to get the distance periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletDistanceIR.Distance"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackPeriod"/>.
		/// </summary>
		public ushort GetDistance()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DISTANCE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DISTANCE, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Returns the value as read by a 12 bit analog to digital converter.
		///  The value is between 0 and 4095.
		///  
		///  <note>
		///   The value returned by <see cref="Tinkerforge.BrickletDistanceIR.GetDistance"/> is averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletDistanceIR.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletDistanceIR.GetAnalogValue"/> is,
		///   if you need the full resolution of the analog to digital converter.
		///  </note>
		///  
		///  If you want the analog value periodically, it is recommended to use the 
		///  callback <see cref="Tinkerforge.BrickletDistanceIR.AnalogValue"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public ushort GetAnalogValue()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Sets a sampling point value to a specific position of the lookup table.
		///  The lookup table is comprised of 128 equidistant analog values with
		///  corresponding distances.
		///  
		///  If you measure a distance of 50cm at the analog value 2048, you
		///  should call this function with (64, 5000). The utilized analog to digital
		///  converter has a resolution of 12 bit. With 128 sampling points on the
		///  whole range, this means that every sampling point has a size of 32
		///  analog values. Thus the analog value 2048 has the corresponding sampling
		///  point 64 = 2048/32.
		///  
		///  Sampling points are saved on the EEPROM of the Distance-IR Bricklet and
		///  loaded again on startup.
		///  
		///  <note>
		///   An easy way to calibrate the sampling points of the Distace-IR Bricklet is
		///   implemented in brickv. If you want to calibrate your Bricklet it is
		///   highly recommended to use this implementation.
		///  </note>
		/// </summary>
		public void SetSamplingPoint(byte position, ushort distance)
		{
			byte[] data_ = new byte[7];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_SAMPLING_POINT, 1, data_);
			LEConverter.To((ushort)7, 2, data_);
			LEConverter.To(position, 4, data_);
			LEConverter.To(distance, 5, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the distance to a sampling point position as set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetSamplingPoint"/>.
		/// </summary>
		public ushort GetSamplingPoint(byte position)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_SAMPLING_POINT, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(position, 4, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_SAMPLING_POINT, out response);

			return LEConverter.UShortFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletDistanceIR.Distance"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletDistanceIR.Distance"/> is only triggered if the distance has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetDistanceCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DISTANCE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackPeriod"/>.
		/// </summary>
		public uint GetDistanceCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletDistanceIR.AnalogValue"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletDistanceIR.AnalogValue"/> is only triggered if the analog value has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public uint GetAnalogValueCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletDistanceIR.DistanceReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off."
		///   "'o'",    "Callback is triggered when the distance is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the distance is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the distance is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the distance is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetDistanceCallbackThreshold(char option, short min, short max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackThreshold"/>.
		/// </summary>
		public void GetDistanceCallbackThreshold(out char option, out short min, out short max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.ShortFrom(5, response);
			max = LEConverter.ShortFrom(7, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off."
		///   "'o'",    "Callback is triggered when the distance is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the distance is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the distance is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the distance is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, ushort min, ushort max)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 7, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out ushort min, out ushort max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.UShortFrom(5, response);
			max = LEConverter.UShortFrom(7, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///   <see cref="Tinkerforge.BrickletDistanceIR.DistanceReached"/>, <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueReached"/>
		///  
		///  are triggered, if the thresholds
		///  
		///   <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackThreshold"/>, <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDistance(out ushort distance)
		{
			distance = GetDistance();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValue(out ushort value)
		{
			value = GetAnalogValue();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetSamplingPoint(byte position, out ushort distance)
		{
			distance = GetSamplingPoint(position);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDistanceCallbackPeriod(out uint period)
		{
			period = GetDistanceCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetAnalogValueCallbackPeriod(out uint period)
		{
			period = GetAnalogValueCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		internal int CallbackDistance(byte[] data_)
		{
			ushort distance = LEConverter.UShortFrom(4, data_);

			((Distance)callbacks[CALLBACK_DISTANCE])(distance);
			return 6;
		}

		internal int CallbackAnalogValue(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValue)callbacks[CALLBACK_ANALOG_VALUE])(value);
			return 6;
		}

		internal int CallbackDistanceReached(byte[] data_)
		{
			ushort distance = LEConverter.UShortFrom(4, data_);

			((DistanceReached)callbacks[CALLBACK_DISTANCE_REACHED])(distance);
			return 6;
		}

		internal int CallbackAnalogValueReached(byte[] data_)
		{
			ushort value = LEConverter.UShortFrom(4, data_);

			((AnalogValueReached)callbacks[CALLBACK_ANALOG_VALUE_REACHED])(value);
			return 6;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Distance))
			{
				callbacks[CALLBACK_DISTANCE] = d;
			}
			else if(d.GetType() == typeof(AnalogValue))
			{
				callbacks[CALLBACK_ANALOG_VALUE] = d;
			}
			else if(d.GetType() == typeof(DistanceReached))
			{
				callbacks[CALLBACK_DISTANCE_REACHED] = d;
			}
			else if(d.GetType() == typeof(AnalogValueReached))
			{
				callbacks[CALLBACK_ANALOG_VALUE_REACHED] = d;
			}
		}
	}
}
